/*
===========================================================================

Doom 3 GPL Source Code
Copyright (C) 1999-2011 id Software LLC, a ZeniMax Media company.
interaction_vs clean-room rebuilt for GPL compatibility by MH, 2012.

This file is part of the Doom 3 GPL Source Code (?Doom 3 Source Code?).

Doom 3 Source Code is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Doom 3 Source Code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Doom 3 Source Code.  If not, see <http://www.gnu.org/licenses/>.

===========================================================================
*/

layout(location = 8)  in vec4 TexCoord;
layout(location = 9)  in vec3 Tangent;
layout(location = 10) in vec3 Binormal;
layout(location = 11) in vec3 Normal;

uniform vec4 u_color_modulate;
uniform vec4 u_color_add;

varying vec4 vertexPosition;
varying vec4 vertexTexCoord;
varying vec4 vertexColor;
varying mat3x3 lightMatrix;

void main ()
{
	// we must use ftransform as Doom 3 needs invariant position
	gl_Position = ftransform ();

	// save on passing through too many interpolants
	vertexPosition = gl_Vertex;
	vertexTexCoord = TexCoord;
	lightMatrix = mat3x3 (Tangent, Binormal, Normal);
	vertexColor = (gl_Color * u_color_modulate) + u_color_add;
}

